Open CASCADE Technology: OpenGl_Layer Class Reference

Open CASCADE Technology 6.9.1

- Main Page
- Related Pages
- Namespaces
- Data Structures
- Files

- Data Structures
- Data Structure Index
- Class Hierarchy
- Data Fields

Public Member Functions | Protected Member Functions
OpenGl_Layer Class Reference

Presentations list sorted within priorities. More...

`#include <OpenGl_Layer.hxx>`

## Public Member Functions
| OpenGl_Layer (const Standard_Integer theNbPriorities=11)
| Initializes associated priority list and layer properties. More...
virtual | ~OpenGl_Layer ()
| Destructor. More...
const Graphic3d_ZLayerSettings & | LayerSettings () const
| Returns settings of the layer object. More...
void | SetLayerSettings (const Graphic3d_ZLayerSettings &theSettings)
| Sets settings of the layer object. More...
const Standard_Boolean | IsSettingEnabled (const Graphic3d_ZLayerSetting theSetting) const
| Returns true if theSetting is enabled for the layer. More...
void | Add (const OpenGl_Structure *theStruct, const Standard_Integer thePriority, Standard_Boolean isForChangePriority=Standard_False)
bool | Remove (const OpenGl_Structure *theStruct, Standard_Integer &thePriority, Standard_Boolean isForChangePriority=Standard_False)
| Remove structure and returns its priority, if the structure is not found, method returns negative value. More...
Standard_Integer | NbStructures () const
Standard_Integer | NbPriorities () const
| Returns the number of available priority levels. More...
Standard_Boolean | Append (const OpenGl_Layer &theOther)
| Append layer of acceptable type (with similar number of priorities or less). Returns Standard_False if the list can not be accepted. More...
const OpenGl_ArrayOfIndexedMapOfStructure & | ArrayOfStructures () const
| Returns array of OpenGL structures. More...
void | InvalidateBVHData ()
| Marks BVH tree for given priority list as dirty and marks primitive set for rebuild. More...
void | Render (const Handle< OpenGl_Workspace > &theWorkspace, const OpenGl_GlobalLayerSettings &theDefaultSettings) const

## Protected Member Functions
void | traverse (OpenGl_BVHTreeSelector &theSelector) const
| Traverses through BVH tree to determine which structures are in view volume. More...
void | renderAll (const Handle< OpenGl_Workspace > &theWorkspace) const
| Iterates through the hierarchical list of existing structures and renders them all. More...
void | renderTraverse (const Handle< OpenGl_Workspace > &theWorkspace) const
| Iterates through the hierarchical list of existing structures and renders only overlapping ones. More...

## Detailed Description

Presentations list sorted within priorities.

## Constructor & Destructor Documentation

OpenGl_Layer::OpenGl_Layer | ( | const Standard_Integer | theNbPriorities = `11` | ) |

Initializes associated priority list and layer properties.

virtual OpenGl_Layer::~OpenGl_Layer | ( |  | ) |
| virtual

Destructor.

## Member Function Documentation

void OpenGl_Layer::Add | ( | const OpenGl_Structure * | theStruct,
|  | const Standard_Integer | thePriority,
|  | Standard_Boolean | isForChangePriority = `Standard_False`
| ) |  |

Standard_Boolean OpenGl_Layer::Append | ( | const OpenGl_Layer & | theOther | ) |

Append layer of acceptable type (with similar number of priorities or less). Returns Standard_False if the list can not be accepted.

const OpenGl_ArrayOfIndexedMapOfStructure& OpenGl_Layer::ArrayOfStructures | ( |  | ) | const
| inline

Returns array of OpenGL structures.

void OpenGl_Layer::InvalidateBVHData | ( |  | ) |

Marks BVH tree for given priority list as dirty and marks primitive set for rebuild.

const Standard_Boolean OpenGl_Layer::IsSettingEnabled | ( | const Graphic3d_ZLayerSetting | theSetting | ) | const
| inline

Returns true if theSetting is enabled for the layer.

const Graphic3d_ZLayerSettings& OpenGl_Layer::LayerSettings | ( |  | ) | const
| inline

Returns settings of the layer object.

Standard_Integer OpenGl_Layer::NbPriorities | ( |  | ) | const
| inline

Returns the number of available priority levels.

Standard_Integer OpenGl_Layer::NbStructures | ( |  | ) | const
| inline

Returns
  the number of structures

bool OpenGl_Layer::Remove | ( | const OpenGl_Structure * | theStruct,
|  | Standard_Integer & | thePriority,
|  | Standard_Boolean | isForChangePriority = `Standard_False`
| ) |  |

Remove structure and returns its priority, if the structure is not found, method returns negative value.

void OpenGl_Layer::Render | ( | const Handle< OpenGl_Workspace > & | theWorkspace,
|  | const OpenGl_GlobalLayerSettings & | theDefaultSettings
| ) |  | const

void OpenGl_Layer::renderAll | ( | const Handle< OpenGl_Workspace > & | theWorkspace | ) | const
| protected

Iterates through the hierarchical list of existing structures and renders them all.

void OpenGl_Layer::renderTraverse | ( | const Handle< OpenGl_Workspace > & | theWorkspace | ) | const
| protected

Iterates through the hierarchical list of existing structures and renders only overlapping ones.

void OpenGl_Layer::SetLayerSettings | ( | const Graphic3d_ZLayerSettings & | theSettings | ) |
| inline

Sets settings of the layer object.

void OpenGl_Layer::traverse | ( | OpenGl_BVHTreeSelector & | theSelector | ) | const
| protected

Traverses through BVH tree to determine which structures are in view volume.

The documentation for this class was generated from the following file:

- OpenGl_Layer.hxx